package de.ivu.elect.presentation.wahlvorschlag.menu;

import javax.annotation.Nullable;
import javax.inject.Inject;

import de.ivu.elect.business.gebietsbaum.boundary.GebietSessionSelect;
import de.ivu.elect.business.gebietsbaum.entity.Gebiet;
import de.ivu.elect.jee.faces.FacesContextUtil;
import de.ivu.elect.presentation.gebietsbaum.GebietNummerFormatter;
import de.ivu.elect.presentation.gebietsbaum.tree.AbstractNoStoreGebietsbaumView;
import de.ivu.elect.presentation.menu.AbstractMenuItemEntry;
import de.ivu.elect.presentation.security.AbstractGebietSecurity;

public class NlUbergeordnetesGebietWechselnMenuItemEntry extends AbstractMenuItemEntry {
  private static final long serialVersionUID = 1L;

  @Inject
  private transient AbstractNoStoreGebietsbaumView gebietsbaumView;

  @Inject
  private transient GebietSessionSelect gebietSessionSelect;

  @Inject
  private transient GebietNummerFormatter gebietNummerFormatter;

  @Override
  protected boolean isDisabledInternal() {
    return false;
  }

  @Override
  protected AbstractGebietSecurity getGebietSecurity() {
    return AbstractGebietSecurity.KEINE_GEBIET_SECURITY;
  }

  @Nullable
  @Override
  public String getTargetViewId() {
    return null; // action
  }

  @Override
  public String doAction() {
    Gebiet neuesGebiet = getUebergeordnetesGebiet();
    if (neuesGebiet != null) {
      gebietSessionSelect.setEntity(neuesGebiet);
      gebietsbaumView.reset();
    }

    return FacesContextUtil.getCurrentViewId();
  }


  @Nullable
  private Gebiet getUebergeordnetesGebiet() {
    Gebiet gebiet = gebietSessionSelect.getEntity();
    if (gebiet == null) {
      return null;
    }
    return gebiet.getUebergeordnetesGebiet();
  }

  @Override
  public boolean isRendered() {
    return getUebergeordnetesGebiet() != null;
  }

  @Override
  protected String getLabel() {
    return getMessage(getLabelKey(), gebietNummerFormatter.getDarstellung(getUebergeordnetesGebiet()));
  }

  @Override
  public String getLabelKey() {
    return "liste.search.gebiet.hoher.label";
  }

  @Override
  public String getIcon() {
    return "fa fa-arrow-circle-up";
  }
}
